/****************************************************
	MARC Template Library 

 
 	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
  Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/

#include "marc8xmlentity.h"



MARC8_XMLEntity::CHARSETTABLE MARC8_XMLEntity::charset[] = {
	{128, 0, "&#128;"}, 
	{129, 0, "&#129;"}, 
	{130, 0, "&#130;"},
	{131, 0, "&#131;"},
	{132, 0, "&#132;"},
	{133, 0, "&#133;"},
	{134, 0, "&#134;"},
	{135, 0, "&#135;"},
	{136, 0, "&#136;"},
	{137, 0, "&#137;"},
	{138, 0, "&#138;"}, 
	{139, 0, "&#139;"},
	{140, 0, "&#140;"},
	{141, 0, "&#141;"},
	{142, 0, "&#142;"},
	{143, 0, "&#143;"},
	{144, 0, "&#144;"},
	{145, 0, "&#145;"},
	{146, 0, "&#146;"},
	{147, 0, "&#147;"},
	{148, 0, "&#148;"}, 
	{149, 0, "&#149;"},
	{150, 0, "&#150;"},
	{151, 0, "&#151;"},
	{152, 0, "&#152;"},
	{153, 0, "&#153;"},
	{154, 0, "&#154;"},
	{155, 0, "&#155;"},
	{156, 0, "&#156;"},
	{157, 0, "&#157;"},
	{158, 0, "&#158;"}, 
	{159, 0, "&#159;"},
	{160, 0, "&#160;"},
	{161, 0, "&#161;"},
	{162, 0, "&#162;"},
	{163, 0, "&#163;"},
	{164, 0, "&#164;"},
	{165, 0, "&#165;"},
	{166, 0, "&#166;"},
	{167, 0, "&#167;"},
	{168, 0, "&#168;"}, 
	{169, 0, "&#169;"},
	{170, 0, "&#170;"},
	{171, 0, "&#171;"},
	{172, 0, "&#172;"},
	{173, 0, "&#173;"},
	{174, 0, "&#174;"},
	{175, 0, "&#175;"},
	{176, 0, "&#176;"},
	{177, 0, "&#177;"},
	{178, 0, "&#178;"}, 
	{179, 0, "&#179;"},
	{180, 0, "&#180;"},
	{181, 0, "&#181;"},
	{182, 0, "&#182;"},
	{183, 0, "&#183;"},
	{184, 0, "&#184;"},
	{185, 0, "&#185;"},
	{186, 0, "&#186;"},
	{187, 0, "&#187;"},
	{188, 0, "&#188;"}, 
	{189, 0, "&#189;"},
	{190, 0, "&#190;"},
	{191, 0, "&#191;"},
	{192, 0, "&#192;"},
	{193, 0, "&#193;"},
	{194, 0, "&#194;"},
	{195, 0, "&#195;"},
	{196, 0, "&#196;"},
	{197, 0, "&#197;"},
	{198, 0, "&#198;"}, 
	{199, 0, "&#199;"},
	{200, 0, "&#200;"},
	{201, 0, "&#201;"},
	{202, 0, "&#202;"},
	{203, 0, "&#203;"},
	{204, 0, "&#204;"},
	{205, 0, "&#205;"},
	{206, 0, "&#206;"},
	{207, 0, "&#207;"},
	{208, 0, "&#208;"},
	{209, 0, "&#209;"},
	{210, 0, "&#210;"},
	{211, 0, "&#211;"},
	{212, 0, "&#212;"},
	{213, 0, "&#213;"},
	{214, 0, "&#214;"},
	{215, 0, "&#215;"},
	{216, 0, "&#216;"},
	{217, 0, "&#217;"},
	{218, 0, "&#218;"},
	{219, 0, "&#219;"},
	{220, 0, "&#220;"},
	{221, 0, "&#221;"},
	{222, 0, "&#222;"},
	{223, 0, "&#223;"},
	{224, 0, "&#224;"},
	{225, 0, "&#225;"},
	{226, 0, "&#226;"},
	{227, 0, "&#227;"},
	{228, 0, "&#228;"},
	{229, 0, "&#229;"},
	{230, 0, "&#230;"},
	{231, 0, "&#231;"},
	{232, 0, "&#232;"},
	{233, 0, "&#233;"},
	{234, 0, "&#234;"},
	{235, 0, "&#235;"},
	{236, 0, "&#236;"},
	{237, 0, "&#237;"},
	{238, 0, "&#238;"},
	{239, 0, "&#239;"},
	{240, 0, "&#240;"},
	{241, 0, "&#241;"},
	{242, 0, "&#242;"},
	{243, 0, "&#243;"},
	{244, 0, "&#244;"},
	{245, 0, "&#245;"},
	{246, 0, "&#246;"},
	{247, 0, "&#247;"},
	{248, 0, "&#248;"},
	{249, 0, "&#249;"},
	{250, 0, "&#250;"},
	{251, 0, "&#251;"},
	{252, 0, "&#252;"},
	{253, 0, "&#253;"},
	{254, 0, "&#254;"},
	{255, 0, "&#255;"}
};



void MARC8_XMLEntity::Encode(MARCStringBuffer & buf, const char * szStr)
{
	int i = 0;
	int c = 0;

	while(szStr[i])
	{
		c = (unsigned char)szStr[i];
		if(c < 127)
		{
			switch(c)
			{
			case 38:
				buf.Append("&amp;");
				break;
			case 60:
				buf.Append("&lt;");
				break;
			case 62:
				buf.Append("&gt;");
				break;
			default:
				buf.Append(szStr[i]);
			break;
			}
		}
		else
		{
		buf.Append(GetXMLNumericEntity(c));
		}
	++i;
	}
}


void MARC8_XMLEntity::Encode(MARCStringBuffer & buf, const MARC_String & ms)
{
	int i = 0;
	int c = 0;

	while(i < ms.StringLength)
	{
		c = (unsigned char)ms.StringPtr[i];
		if(c < 127)
		{
			switch(c)
			{
			case 38:
				buf.Append("&amp;");
				break;
			case 60:
				buf.Append("&lt;");
				break;
			case 62:
				buf.Append("&gt;");
				break;
			default:
				buf.Append((char)c);
			break;
			}
		}
		else
		{
		buf.Append(GetXMLNumericEntity(c));
		}
	++i;
	}
}



int MARC8_XMLEntity::Encode(MARC_String & output, const MARC_String & ms)
{
	int i = 0;
	int c = 0;
	int lr = 0;

	while(i < ms.StringLength)
	{
		c = (unsigned char)ms.StringPtr[i];

		if(c < 127)
		{
			switch(c)
			{
			case 38:
				strcpy((char *)output.StringPtr + lr, "&amp;");
				lr += 5;
				break;
			case 60:
				strcpy((char *)output.StringPtr + lr, "&lt;");
				lr += 4;
				break;
			case 62:
				strcpy((char *)output.StringPtr + lr, "&gt;");
				lr += 4;
				break;
			default:
				(char)output.StringPtr[lr] = c;
				lr ++;
				(char)output.StringPtr[lr + 1] = 0;
			break;
			}
		}
		else
		{
		strcpy((char *)output.StringPtr + lr, GetXMLNumericEntity(c));
		lr += 6;
		}
		if(lr >= output.StringLength) return -1;
	++i;
	}

	return lr;
}