/****************************************************
	MARC Template Library 

	Version 0.6.1 - Released 12 June 2002
     Version 0.6 - Released 10 June 2002
	 Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
 Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/

#ifndef _MARC8_XMLENTITY_H
#define _MARC8_XMLENTITY_H

#include "MARCStringBuffer.h"

class MARC8_XMLEntity
{
public:

	static const char * GetXMLCharacterEntity(int i)
	{
		return charset[i - 128].characterEntity;
	}
	
	static const char * GetXMLNumericEntity(int i)
	{
		return charset[i - 128].numericEntity;
	}

	
	static int Encode(MARC_String & output, const MARC_String & ms); // fastest

	static void Encode(MARCStringBuffer & buf, const char * szStr);
	static void Encode(MARCStringBuffer & buf, const MARC_String & ms);


private:

	static struct CHARSETTABLE{
		int character;
		char * characterEntity;
		char * numericEntity;
	} charset[];

};






#endif