/****************************************************
	MARC Template Library 

	Version 0.6.1 - Released 12 June 2002
	Version 0.6 - Released 10 June 2002
	 Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/

#include "marcdatafield.h"



void MARCDataField::MoveFirst()
{
	iOffset = 3;
}

void MARCDataField::MoveNext()
{
	while(iOffset < iLength)
	{
		if(buf[iOffset] == MARC_ST)	{ ++iOffset; return; }
	++iOffset;
	}
}

bool MARCDataField::IsEnd()
{
	return (iOffset < iLength) ? false : true;
}





char MARCDataField::SubFieldCode()
{
	return buf[iOffset];
}


MARC_String MARCDataField::SubFieldString()
{
	MARC_String str;
	
	int i = iOffset;
	while(i < iLength)
	{
	if((buf[i] == MARC_ST) || (buf[i] == MARC_FT))
		break;
	++i;
	}

	if(i > iOffset)
	{
	int l = i - iOffset;
	str.Init((char *)buf + iOffset + 1, l - 1);
	}
	return str;

}



MARC_String MARCDataField::GetSubField(char c)
{
	MARC_String str;
	char * start = 0, * end = 0;

	int i = 0;
	while(i < iLength)
	{
		if(start)
		{
		if((buf[i] == 30) || (buf[i] == 31))
		{
		end = buf + i;
		int l = end - start;
		str.Init((char *)start, l);
		break;
		}

		}

		if((buf[i - 1] == 31) && (buf[i] == c))
		{
		start = buf + i + 1;
		}

	++i;
	}

	return str;
}


string MARCDataField::FormatString(const char * szFormat, bool bIndicator)
{
	string str;

	if(!buf) return str;
	if(!szFormat) return str;

	if(bIndicator)
	{
		char it[3];

		if(strlen(buf) > 2)
		{
		memcpy(it, buf, 2);
		it[2] = 0;
		str = it;
		str += " ";
		}
	}

	int i = 0;
	while(szFormat[i])
	{
	if(szFormat[i] == 32)	str += " ";
	else
		{
		string s;
		s = GetSubField(szFormat[i]);
		str += s;
		}
	++i;
	}

	return str;
}

string MARCDataField::FormatString(int iLeftTruncate, char cSubFieldDelimiter)
{
	string str;

	if(!buf) return str;
	if(iLength < iLeftTruncate) return str;

	char * tmpBuf = new char [iLength + 1];

	memcpy(tmpBuf, buf + iLeftTruncate, iLength - iLeftTruncate);
	tmpBuf[iLength - iLeftTruncate - 1] = 0;

	RemoveSubFieldDelimiters(tmpBuf, iLength, cSubFieldDelimiter); 
	str = tmpBuf;
	delete [] tmpBuf;

	return str;
}






/*
void MARCDataField::RemoveSubFieldDelimiters(string & str)
{
	//Not really the way to do this properly but it will do for the moment
	int i = 0;
	int iLen = str.length();

	while(i < iLen)
	{
		if(str[i] == 31) 
		{
		str[i++] = 32;
		memmove((char *)str.c_str() + i, (char *)str.c_str() + i + 1, iLen - i);
		}
		else
		{
		++i;
		} 
	}
}
*/

void MARCDataField::RemoveSubFieldDelimiters(char * buf, int iLen, char cSubFieldDelimiter)
{
	int i = 0;

	if(cSubFieldDelimiter)
	{
		while(buf[i])
		{
			if(buf[i] == 31) 
			{
			buf[i++] = cSubFieldDelimiter;
			}
		++i;
		}
	}
	else
	{
	
	int n = 0;
	while(buf[i])
	{
		if(buf[i] == 31) 
		{
			if(i)
			{
				memmove(buf + i, buf + i + 1, iLen - i);
				buf[i] = 32;
			}
			else
				memmove(buf + i, buf + i + 2, iLen - i);
		}
		else
		{
		++i;
		} 
	}
	}
}