/****************************************************
	MARC Template Library 
	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCDATAFIELD_H
#define _MARCDATAFIELD_H



#include <string>

#include "marcdir.h"
#include "marctag.h"
#include "marcstring.h"
#include "marcdef.h"
#include "marcfield.h"

using namespace std;



class MARCDataField : public MARCField
{
public:
	void MoveFirst();
	void MoveNext();
	bool IsEnd();

	char SubFieldCode();

	MARC_String SubFieldString();
	//wstring SubFieldWString();

	virtual MARC_String GetString() {  return MARC_String(buf, iLength ? --iLength : 0); }


	string FormatString(const char * szFormat, bool bIndicators = false);
	string FormatString(int iLeftTruncate = 2, char cSubFieldDelimiter = 0);

	MARC_String GetSubField(char c);

	//wstring GetWString(char * szFormat = NULL, bool bIndicator = false);
	//wstring GetWSubField(char c);

	char GetIndicator(MARCIndicator i)
		{
		if(!buf) return 0;
		return buf[i];
		}

	 virtual MARCField * Clone() const { return new MARCDataField(*this); }


protected:
 
	void MARCDataField::RemoveSubFieldDelimiters(char * buf, int iLen, char cSubFieldDelimiter = 0);

};

#endif