/****************************************************
	MARC Template Library 

  	Version 0.6.1 - Released 12 June 2002
	Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#include "marcfield.h"
//#include <iostream>

MARCField::MARCField()
{
	buf = 0;
	iLength = 0;
	iOffset = 0;
	bOwnMem = true;
}

MARCField::~MARCField()
{
	DeleteMem();
}

MARCField::MARCField(const MARCField & mf)
{
	mTag = mf.mTag;
	iLength = mf.iLength;
	iOffset = mf.iOffset;

	if(mf.buf)
	{
	bOwnMem = true;
	buf = new char[iLength];
	memcpy(buf, mf.buf, iLength);
	}
}
/*
bool MARCField::Parse(char * szBaseAddressOfData, const MARCDir & md, bool bOwnsMemory)
{
	mTag = md.tag;
	InitMem(szBaseAddressOfData + md.iStartPos, md.iLength, bOwnsMemory);
	return true;
}*/

bool MARCField::Parse(const MARCTag & tag, char * szBuf, int iLen, bool bOwnsMemory)
{
	mTag = tag;
	InitMem(szBuf, iLen, bOwnsMemory);
	return true;
}



void MARCField::InitMem(char * szBuf, int iLen, bool bOwnsMemory)
{
	DeleteMem();
	bOwnMem = bOwnsMemory;
	iLength = iLen;

	if(bOwnMem)
	{
	buf = new char[iLength];
	memcpy(buf, szBuf, iLength);
	}
	else
	{
	buf = szBuf;
	}
}

void MARCField::DeleteMem()
{
	if(bOwnMem && buf)
	{
	delete [] buf;
	}
}
	
void MARCField::OwnMem()
{
	if(!bOwnMem)
	{
	bOwnMem = true;
	char * szBuf = buf;
	buf = new char[iLength];
	memcpy(buf, szBuf, iLength);
	}
}



MARCField & MARCField::operator=(const MARCField & f)
{
	if(this != &f)
	{
	mTag = f.mTag;
	InitMem(f.buf, f.iLength, f.bOwnMem);
	}	
	return *this;
}

bool MARCField::operator<(MARCField & field)
{
	int i = 0;
	i = (iOffset <= field.iOffset) ? iOffset : field.iOffset;
	return (memcmp(buf, field.buf, i) < 0) ? true : false;
}