/****************************************************
	MARC Template Library 

    Version 0.6.1 - Released 12 June 2002
	Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCFIELD_H
#define _MARCFIELD_H



#include <string>
#include "marcdef.h"
#include "marcdir.h"
#include "marctag.h"
#include "marcstring.h"


using namespace std;

class MARCField 
{
public:
	MARCField();

	virtual ~MARCField();
	MARCField(const MARCField & mf);

//	bool Parse(char * szBaseAddressOfData, const MARCDir & md, bool bOwnsMemory = true);
	bool Parse(const MARCTag & tag, char * szBuf, int iLen, bool bOwnsMemory = true);

	MARCTag & Tag() { return mTag; }

	virtual MARC_String GetString() = 0;

	MARC_String GetBuffer() { return MARC_String(buf, iLength); }

	virtual MARCField * Clone() const = 0;

	void OwnMem();
	bool IsOwnMem() { return bOwnMem; }


	MARCField & operator=(const MARCField & f);
	bool operator<(MARCField & field);

protected:
	MARCTag mTag;

	void DeleteMem();
	void InitMem(char * szBuf, int iLen, bool bOwnsMemory);


	bool bOwnMem;

	char * buf;
	int iLength;
	int iOffset;
};

#endif