/****************************************************
	MARC Template Library 

   	Version 0.6.1 - Released 12 June 2002
	Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCLEADER_H
#define _MARCLEADER_H

#include <string>
#include "marcutil.h"
#include "marcstring.h"

using namespace std;


enum MARCEncoding { charEncoding_MARC8, charEncoding_Unicode, charEncoding_Unknown };

template <int TLeaderLength = 24>
class MARCLeader
{
public:
	bool Parse(char * szBuf, int iLength);

	virtual int GetRecLength() = 0;
	virtual int GetBaseAddressOfData() = 0;
	virtual MARCEncoding GetCharEncoding() = 0;

	int GetLeaderLength() { return TLeaderLength; }

	inline MARC_String GetBuffer();

protected:

	char buf[TLeaderLength + 1];
};

template <int TLeaderLength>
bool MARCLeader<TLeaderLength>::Parse(char * szBuf, int iLength)
{
	if(iLength < TLeaderLength) return false;
	memcpy(buf, szBuf, TLeaderLength);
	buf[TLeaderLength] = 0;
	return true;
}

template <int TLeaderLength>
MARC_String MARCLeader<TLeaderLength>::GetBuffer()
{
	return MARC_String(buf, TLeaderLength);
}





#endif