/****************************************************
	MARC Template Library 

  	Version 0.6.1 - Released 12 June 2002
	Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
  Version 0.4.5 - Released 5th April 2002
  Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/

//#include "static_marcrecord.h"


#ifndef _MARCSORT_H
#define _MARCSORT_H

#include <functional>

using namespace std;

//, const char * szTag = "245"

template<class TRecType, bool bDiscardNonFilingChars = false>
struct MARCTitleSort : public binary_function<TRecType, TRecType, bool> 
{
    bool operator()(TRecType & m1, TRecType & m2) 
	{
	return (m1.GetTitleString(bDiscardNonFilingChars) < m2.GetTitleString(bDiscardNonFilingChars));
	}
};



template<class TRecType, const char * sTag>
struct MARCSort : public binary_function<TRecType, TRecType, bool> 
{
	bool operator()(TRecType & m1, TRecType & m2)
	{
	m1.FindFirst(sTag);
	m2.FindFirst(sTag);

	return (m1.Field() < m2.Field());
	}
};

#endif