/****************************************************
	MARC Template Library 

   	Version 0.6.1 - Released 12 June 2002
	Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCSTREAMEVENT_H
#define _MARCSTREAMEVENT_H


#include <string>
#include "marcrecordevent.h"
#include "marcdatafield.h"
#include "marccontrolfield.h"
#include "marcutil.h"
#include "marcbuffer.h"


using namespace std;



template<class TLeader, class TDir>
class MARCStreamEvent : public MARCRecordEvent<TLeader, TDir>
{
public:


	bool Parse(char * szBuf, long lLen);
	bool Parse(char * szFileName);

	virtual void startStream() = 0; 
	virtual void endStream() = 0;

};


template<class TLeader, class TDir>
bool MARCStreamEvent<TLeader, TDir>::Parse(char * szBuf, long lLen)
{
	startStream();

	long lOffset = 0;

	while(MARCRecordEvent<TLeader, TDir>::Parse(szBuf + lOffset, lLen - lOffset))
	{
	lOffset += GetRecordLength();
	}

	endStream();

	return true;
}


template<class TLeader, class TDir>
bool MARCStreamEvent<TLeader, TDir>::Parse(char * szFileName)
{
	MARCBuffer<MARCRecordEvent<TLeader, TDir> > buf;

	buf.LoadFromFile(szFileName);
	startStream();
	while(buf.Read(*this));
	endStream();

	return true;
}

#endif
