/****************************************************
	MARC Template Library 

	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
	 Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
	Version 0.3 - Released 18th January 2002
	Version 0.2 - Released 14th January 2002
	Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCSTRINGBUFFER_H
#define _MARCSTRINGBUFFER_H

#include <string>
#include "marcstring.h"
#include "marctag.h"


using namespace std;


class MARCStringBuffer  
{
public:

	MARCStringBuffer(long lInitialSize = 1000);
	MARCStringBuffer(const MARCStringBuffer & fsb);
	virtual ~MARCStringBuffer();


	void Append(const char * szStr);
	void Append(char c);
	void Append(long l);
	void Append(int i);
	void Append(const MARCStringBuffer & fsb);
	void Append(MARC_String & ms);
	void Append(const char * szStr, int iLen);
	void Append(MARCTag & mt);
	void AppendMARC8EntityEncode(MARC_String & ms);

	void Insert(const char * szStr, long lOffset = 0);

	char * GetBuffer() { return buffer; }
	long GetBufferLength() { return lEnd; }

	void Clear(bool bReleaseMemory = false);

	MARCStringBuffer & operator=(const MARCStringBuffer & fcb);
	MARCStringBuffer operator+(MARCStringBuffer & fcb);

private:

	char * buffer;
	long lLength;
	long lEnd;
};




#endif 