/****************************************************
	MARC Template Library 

	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
	Version 0.3 - Released 18th January 2002
	Version 0.2 - Released 14th January 2002
	Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#include "marctag.h"


MARCTag::MARCTag()
{
	buf[0] = 0; 
}


MARCTag::~MARCTag()
{

}

MARCTag::MARCTag(const MARCTag & mt)
{
	buf[0] = mt.buf[0];
	buf[1] = mt.buf[1];
	buf[2] = mt.buf[2];
	buf[3] = 0;
}

void MARCTag::Parse(char * szBuf, int iLen)
{
	if(iLen >= 3)
	{
	buf[0] = szBuf[0];
	buf[1] = szBuf[1];
	buf[2] = szBuf[2];
	buf[3] = 0;
	}
	else
	{
	buf[0] = 0;
	}
}

const char * MARCTag::c_str()
{ 
	buf[3] = 0; 
	return buf; 
} 

void MARCTag::Clear()
{
	buf[0] = 0;
}

bool MARCTag::operator<(const MARCTag & mt) const
{
	return (strcmp(buf, mt.buf) < 0); 
}


bool MARCTag::operator==(const MARCTag & mt) const
{
	return (strcmp(buf, mt.buf) == 0);
}

bool MARCTag::operator==(const char * szStr) const
{
	return (strcmp(buf, szStr) == 0);
}

bool MARCTag::IsControl()
{
	return ((buf[0] == '0') && (buf[1] == '0')) ? true : false;
}

bool MARCTag::IsData()
{
	return ((buf[0] != '0') || (buf[1] != '0')) ? true : false;
}

MARCTag & MARCTag::operator=(const MARCTag & mt)
{
	if(&mt != this)
	{
	buf[0] = mt.buf[0];
	buf[1] = mt.buf[1];
	buf[2] = mt.buf[2];
	buf[3] = 0;
	}
	return *this;
}

MARCTag & MARCTag::operator=(const string & str)
{
	if(str.length() >= 3)
	{
		memcpy(buf, str.c_str(), 3);
		buf[3] = 0;
	}
	else
	{
		buf[0] = 0;
	}
	return *this;
}


MARCTag & MARCTag::operator=(const char * szStr)
{
	if(strlen(szStr) <= 3)
	{
		memcpy(buf, szStr, 3);
		buf[3] = 0;
	}
	else
	{
		buf[0] = 0;
	}
	return *this;
}