/****************************************************
	MARC Template Library 

	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
    Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
    Version 0.3 - Released 18th January 2002
	Version 0.2 - Released 14th January 2002
	Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARC_TEMPLATE_LIBRARY_H
#define _MARC_TEMPLATE_LIBRARY_H




// MARC RECORD TEMPLATES  /////////////////////////
#include "marcrecord.h"
#include "marcrecordevent.h"
#include "marcstreamevent.h"



#include "marc21_dir.h"
#include "marc21_leader.h"
#include "unimarc_dir.h"
#include "unimarc_leader.h"



typedef MARCRecord<MARC21_Leader, MARC21_Dir> MARC21Record;
typedef MARCRecordEvent<MARC21_Leader, MARC21_Dir> MARC21EventRecord;
typedef MARCStreamEvent<MARC21_Leader, MARC21_Dir> MARC21EventStream;


typedef MARCRecord<UNIMARC_Leader, UNIMARC_Dir> UNIMARCRecord;
//typedef MARCEventRecord<UNIMARC_Leader, UNIMARC_Dir> UNIMARCEventRecord;



// MARC FIELDS ///////////////////////////

#include "marcfield.h"
#include "marcdatafield.h"
#include "marccontrolfield.h"

// STREAMS & BUFFERS  //////////////////////////////////
#include "marcbuffer.h"
//#include "MARCStringBuffer.h"
//#include "marcstream.h"

//MARC FORMATING & CONVERSION /////////////////////////

//#include "marctodc.h" // MARC To Dublin Core
//#include "marctohtml.h" // MARC to HTML
//#include "marctobiblio.h" //Create Bibliographies from MARC records
//#include "marctotext.h"
//#include "xmarc.h"
//#include "marcpm.h"

//MARC UTIL ////////////////////////////////

#include "marcsort.h"

#include "marc8xmlentity.h"





#endif