// marctoxml.h: interface for the marctoxml class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MARCTOXML_H__901A6DEF_7C99_11D6_8CFD_D5168F4D7C34__INCLUDED_)
#define AFX_MARCTOXML_H__901A6DEF_7C99_11D6_8CFD_D5168F4D7C34__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../include/mtl.h"
/*#include <iostream>
#include <vector>
#include <algorithm>
#include <time.h>*/
//#include <windows.h>

using namespace std;

class MARCXML : public MARC21EventStream
{
public:

	MARCXML() : buffer(1000000), iNumRec(0) { }

	int iNumRec;
	clock_t start, finish;

	double GetDuration() { double duration = (double)(finish - start) / CLOCKS_PER_SEC; return duration; }


	void startStream() 
	{
	start = clock();
	buffer.Append("<?xml version=\"1.0\"?><collection xmlns=\"http://www.loc.gov/MARC21/slim\""
				" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"" 
				" xsi:schemaLocation=\"http://www.loc.gov/MARC21/slim"
				" http://www.loc.gov/standards/marcxml/schema/MARC21slim.xsd\""
				" type=\"Bibliographic\">");
	} 
	void endStream() 
	{
	buffer.Append("</collection>");
	finish = clock();
	} 

	void startRecord(MARC21_Leader & leader) 
	{
	++ iNumRec;
	buffer.Append("<record><leader>");
	buffer.Append(leader.GetBuffer());
	buffer.Append("</leader>");
	}

	void endRecord()
	{
	buffer.Append("</record>");
	}

    void controlField(MARCControlField & mf)
	{
	buffer.Append("<controlfield tag=\"");
	buffer.Append(mf.Tag());
	buffer.Append("\">");
	buffer.Append(mf.GetString());
	buffer.Append("</controlfield>");
	}

    bool dataField(MARCDataField & mf)
	{
	buffer.Append("<datafield tag=\"");
	buffer.Append(mf.Tag());
	buffer.Append("\" ind1=\"");
	buffer.Append(mf.GetIndicator(ind1));
	buffer.Append("\" ind2=\"");
	buffer.Append(mf.GetIndicator(ind2));
	buffer.Append("\">");
	return true;
	}

    void subField(char code, MARC_String & ms)
	{
	buffer.Append("<subfield code=\"");
	buffer.Append(code);
	buffer.Append("\">");
	buffer.AppendMARC8EntityEncode(ms);
	buffer.Append("</subfield>");
	}

	void endDataField()
	{
	buffer.Append("</datafield>");
	}

	MARCStringBuffer buffer;
};


#endif // !defined(AFX_MARCTOXML_H__901A6DEF_7C99_11D6_8CFD_D5168F4D7C34__INCLUDED_)
